package practice5;

import java.io.IOException;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;

import javax.jdo.JDOObjectNotFoundException;
import javax.jdo.PersistenceManager;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.google.api.client.auth.oauth2.Credential;
import com.google.api.client.extensions.jdo.auth.oauth2.JdoCredentialStore;
import com.google.api.client.googleapis.auth.oauth2.GoogleAuthorizationCodeRequestUrl;
import com.google.api.client.googleapis.auth.oauth2.GoogleAuthorizationCodeTokenRequest;
import com.google.api.client.googleapis.auth.oauth2.GoogleCredential;
import com.google.api.client.googleapis.auth.oauth2.GoogleTokenResponse;
import com.google.api.client.http.HttpTransport;
import com.google.api.client.http.javanet.NetHttpTransport;
import com.google.api.client.json.jackson.JacksonFactory;
import com.google.api.services.calendar.Calendar;
import com.google.api.services.calendar.Calendar.CalendarList;
import com.google.api.services.calendar.model.CalendarListEntry;
import com.google.appengine.api.users.User;
import com.google.appengine.api.users.UserService;
import com.google.appengine.api.users.UserServiceFactory;



public class ReadServlet extends HttpServlet {

    public void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
    	
		UserService userService = UserServiceFactory.getUserService();
		
		
		if (userService.isUserLoggedIn()) {
			
			User user = userService.getCurrentUser();
			String email = user.getEmail();
			
			
			JdoCredentialStore cs = new JdoCredentialStore(PMF.get());
			GoogleCredential credential = new GoogleCredential();
			
			try {
				if (! cs.load(email, credential)) {
					//Forward to TokenRequestServlet
					RequestDispatcher rd = req.getRequestDispatcher("/tokenrequest");
					req.setAttribute("email", email);
					rd.forward(req, resp);
					return;
				}
			}
			catch(IOException e) {
				e.printStackTrace();
			}
			
			//Set up
		    HttpTransport httpTransport = new NetHttpTransport();
		    JacksonFactory jsonFactory = new JacksonFactory();
		    
		    Calendar service = new Calendar(httpTransport, jsonFactory, credential);
		  
		    
		    
		      com.google.api.services.calendar.model.CalendarList calendarList = service.calendarList().list().execute();
		      List<CalendarListEntry> items = calendarList.getItems();
		      
		      List<String> result = new ArrayList<String>();
		      if(items != null) {
		        for (CalendarListEntry calendarListEntry : items) {
		          result.add(calendarListEntry.getSummary());
		        }
		      }
		     
		    

			req.setAttribute("user", user);
    		req.setAttribute("url", "/");
        	req.setAttribute("calendars", result);
		}
    	else {
    		req.setAttribute("url", userService.createLoginURL("/"));
    	}
    
    	RequestDispatcher rd = req.getRequestDispatcher("/calendars.jsp");
    	rd.forward(req, resp);
    }
    
    public void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
    	doGet(req, resp);
    }
}