/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.calendar.model;

import com.google.api.client.json.GenericJson;

/**
 * Model definition for Acl.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Calendar API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Acl extends GenericJson {

  /**
   * ETag of the collection.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String etag;

  /**
   * List of rules on the access control list.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<AclRule> items;

  static {
    // hack to force ProGuard to consider AclRule used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(AclRule.class);
  }

  /**
   * Type of the collection ("calendar#acl").
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * Token used to access the next page of this result. Omitted if no further results are available.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String nextPageToken;

  /**
   * ETag of the collection.
   * The value returned may be {@code null}.
   */
  public String getEtag() {
    return etag;
  }

  /**
   * ETag of the collection.
   * The value set may be {@code null}.
   */
  public Acl setEtag(String etag) {
    this.etag = etag;
    return this;
  }

  /**
   * List of rules on the access control list.
   * The value returned may be {@code null}.
   */
  public java.util.List<AclRule> getItems() {
    return items;
  }

  /**
   * List of rules on the access control list.
   * The value set may be {@code null}.
   */
  public Acl setItems(java.util.List<AclRule> items) {
    this.items = items;
    return this;
  }

  /**
   * Type of the collection ("calendar#acl").
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * Type of the collection ("calendar#acl").
   * The value set may be {@code null}.
   */
  public Acl setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Token used to access the next page of this result. Omitted if no further results are available.
   * The value returned may be {@code null}.
   */
  public String getNextPageToken() {
    return nextPageToken;
  }

  /**
   * Token used to access the next page of this result. Omitted if no further results are available.
   * The value set may be {@code null}.
   */
  public Acl setNextPageToken(String nextPageToken) {
    this.nextPageToken = nextPageToken;
    return this;
  }

}
