/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.calendar.model;

import com.google.api.client.json.GenericJson;
import com.google.api.client.util.DateTime;

/**
 * Model definition for Colors.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Calendar API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Colors extends GenericJson {

  /**
   * Palette of calendar colors, mapping from the color ID to its definition. An 'calendarListEntry'
   * resource refers to one of these color IDs in its 'color' field. Read-only.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.Map<String, ColorDefinition> calendar;

  static {
    // hack to force ProGuard to consider ColorDefinition used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(ColorDefinition.class);
  }

  /**
   * Palette of event colors, mapping from the color ID to its definition. An 'event' resource may
   * refer to one of these color IDs in its 'color' field. Read-only.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.Map<String, ColorDefinition> event;

  static {
    // hack to force ProGuard to consider ColorDefinition used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(ColorDefinition.class);
  }

  /**
   * Type of the resource ("calendar#colors").
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * Last modification time of the color palette (as a RFC 3339 timestamp). Read-only.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private DateTime updated;

  /**
   * Palette of calendar colors, mapping from the color ID to its definition. An 'calendarListEntry'
   * resource refers to one of these color IDs in its 'color' field. Read-only.
   * The value returned may be {@code null}.
   */
  public java.util.Map<String, ColorDefinition> getCalendar() {
    return calendar;
  }

  /**
   * Palette of calendar colors, mapping from the color ID to its definition. An 'calendarListEntry'
   * resource refers to one of these color IDs in its 'color' field. Read-only.
   * The value set may be {@code null}.
   */
  public Colors setCalendar(java.util.Map<String, ColorDefinition> calendar) {
    this.calendar = calendar;
    return this;
  }

  /**
   * Palette of event colors, mapping from the color ID to its definition. An 'event' resource may
   * refer to one of these color IDs in its 'color' field. Read-only.
   * The value returned may be {@code null}.
   */
  public java.util.Map<String, ColorDefinition> getEvent() {
    return event;
  }

  /**
   * Palette of event colors, mapping from the color ID to its definition. An 'event' resource may
   * refer to one of these color IDs in its 'color' field. Read-only.
   * The value set may be {@code null}.
   */
  public Colors setEvent(java.util.Map<String, ColorDefinition> event) {
    this.event = event;
    return this;
  }

  /**
   * Type of the resource ("calendar#colors").
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * Type of the resource ("calendar#colors").
   * The value set may be {@code null}.
   */
  public Colors setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Last modification time of the color palette (as a RFC 3339 timestamp). Read-only.
   * The value returned may be {@code null}.
   */
  public DateTime getUpdated() {
    return updated;
  }

  /**
   * Last modification time of the color palette (as a RFC 3339 timestamp). Read-only.
   * The value set may be {@code null}.
   */
  public Colors setUpdated(DateTime updated) {
    this.updated = updated;
    return this;
  }

}
