/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.calendar.model;

import com.google.api.client.json.GenericJson;

/**
 * Model definition for Error.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Calendar API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Error extends GenericJson {

  /**
   * Domain, or broad category, of the error.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String domain;

  /**
   * Specific reason for the error. Some of the possible values are: - "groupTooBig" - The group of
   * users requested is too large for a single query.  - "tooManyCalendarsRequested" - The number of
   * calendars requested is too large for a single query.  - "notFound" - The requested resource was
   * not found.  - "internalError" - The API service has encountered an internal error.  Additional
   * error types may be added in the future, so clients should gracefully handle additional error
   * statuses not included in this list.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String reason;

  /**
   * Domain, or broad category, of the error.
   * The value returned may be {@code null}.
   */
  public String getDomain() {
    return domain;
  }

  /**
   * Domain, or broad category, of the error.
   * The value set may be {@code null}.
   */
  public Error setDomain(String domain) {
    this.domain = domain;
    return this;
  }

  /**
   * Specific reason for the error. Some of the possible values are: - "groupTooBig" - The group of
   * users requested is too large for a single query.  - "tooManyCalendarsRequested" - The number of
   * calendars requested is too large for a single query.  - "notFound" - The requested resource was
   * not found.  - "internalError" - The API service has encountered an internal error.  Additional
   * error types may be added in the future, so clients should gracefully handle additional error
   * statuses not included in this list.
   * The value returned may be {@code null}.
   */
  public String getReason() {
    return reason;
  }

  /**
   * Specific reason for the error. Some of the possible values are: - "groupTooBig" - The group of
   * users requested is too large for a single query.  - "tooManyCalendarsRequested" - The number of
   * calendars requested is too large for a single query.  - "notFound" - The requested resource was
   * not found.  - "internalError" - The API service has encountered an internal error.  Additional
   * error types may be added in the future, so clients should gracefully handle additional error
   * statuses not included in this list.
   * The value set may be {@code null}.
   */
  public Error setReason(String reason) {
    this.reason = reason;
    return this;
  }

}
