/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.calendar.model;

import com.google.api.client.json.GenericJson;

/**
 * Model definition for EventReminder.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Calendar API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class EventReminder extends GenericJson {

  /**
   * The method used by this reminder. Possible values are: - "email" - Reminders are sent via
   * email.  - "sms" - Reminders are sent via SMS.  - "popup" - Reminders are sent via a UI popup.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String method;

  /**
   * Number of minutes before the start of the event when the reminder should trigger.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Integer minutes;

  /**
   * The method used by this reminder. Possible values are: - "email" - Reminders are sent via
   * email.  - "sms" - Reminders are sent via SMS.  - "popup" - Reminders are sent via a UI popup.
   * The value returned may be {@code null}.
   */
  public String getMethod() {
    return method;
  }

  /**
   * The method used by this reminder. Possible values are: - "email" - Reminders are sent via
   * email.  - "sms" - Reminders are sent via SMS.  - "popup" - Reminders are sent via a UI popup.
   * The value set may be {@code null}.
   */
  public EventReminder setMethod(String method) {
    this.method = method;
    return this;
  }

  /**
   * Number of minutes before the start of the event when the reminder should trigger.
   * The value returned may be {@code null}.
   */
  public Integer getMinutes() {
    return minutes;
  }

  /**
   * Number of minutes before the start of the event when the reminder should trigger.
   * The value set may be {@code null}.
   */
  public EventReminder setMinutes(Integer minutes) {
    this.minutes = minutes;
    return this;
  }

}
