/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.calendar.model;

import com.google.api.client.json.GenericJson;
import com.google.api.client.util.DateTime;

/**
 * Model definition for FreeBusyResponse.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Calendar API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class FreeBusyResponse extends GenericJson {

  /**
   * List of free/busy information for calendars.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.Map<String, FreeBusyCalendar> calendars;

  static {
    // hack to force ProGuard to consider FreeBusyCalendar used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(FreeBusyCalendar.class);
  }

  /**
   * Expansion of groups.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.Map<String, FreeBusyGroup> groups;

  static {
    // hack to force ProGuard to consider FreeBusyGroup used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(FreeBusyGroup.class);
  }

  /**
   * Type of the resource ("calendar#freeBusy").
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * The end of the interval.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private DateTime timeMax;

  /**
   * The start of the interval.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private DateTime timeMin;

  /**
   * List of free/busy information for calendars.
   * The value returned may be {@code null}.
   */
  public java.util.Map<String, FreeBusyCalendar> getCalendars() {
    return calendars;
  }

  /**
   * List of free/busy information for calendars.
   * The value set may be {@code null}.
   */
  public FreeBusyResponse setCalendars(java.util.Map<String, FreeBusyCalendar> calendars) {
    this.calendars = calendars;
    return this;
  }

  /**
   * Expansion of groups.
   * The value returned may be {@code null}.
   */
  public java.util.Map<String, FreeBusyGroup> getGroups() {
    return groups;
  }

  /**
   * Expansion of groups.
   * The value set may be {@code null}.
   */
  public FreeBusyResponse setGroups(java.util.Map<String, FreeBusyGroup> groups) {
    this.groups = groups;
    return this;
  }

  /**
   * Type of the resource ("calendar#freeBusy").
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * Type of the resource ("calendar#freeBusy").
   * The value set may be {@code null}.
   */
  public FreeBusyResponse setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * The end of the interval.
   * The value returned may be {@code null}.
   */
  public DateTime getTimeMax() {
    return timeMax;
  }

  /**
   * The end of the interval.
   * The value set may be {@code null}.
   */
  public FreeBusyResponse setTimeMax(DateTime timeMax) {
    this.timeMax = timeMax;
    return this;
  }

  /**
   * The start of the interval.
   * The value returned may be {@code null}.
   */
  public DateTime getTimeMin() {
    return timeMin;
  }

  /**
   * The start of the interval.
   * The value set may be {@code null}.
   */
  public FreeBusyResponse setTimeMin(DateTime timeMin) {
    this.timeMin = timeMin;
    return this;
  }

}
