/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.calendar.model;

import com.google.api.client.json.GenericJson;

/**
 * Model definition for Setting.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Calendar API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Setting extends GenericJson {

  /**
   * ETag of the resource.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String etag;

  /**
   * Name of the user setting.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String id;

  /**
   * Type of the resource ("calendar#setting").
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * Value of the user setting. The format of the value depends on the ID of the setting.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String value;

  /**
   * ETag of the resource.
   * The value returned may be {@code null}.
   */
  public String getEtag() {
    return etag;
  }

  /**
   * ETag of the resource.
   * The value set may be {@code null}.
   */
  public Setting setEtag(String etag) {
    this.etag = etag;
    return this;
  }

  /**
   * Name of the user setting.
   * The value returned may be {@code null}.
   */
  public String getId() {
    return id;
  }

  /**
   * Name of the user setting.
   * The value set may be {@code null}.
   */
  public Setting setId(String id) {
    this.id = id;
    return this;
  }

  /**
   * Type of the resource ("calendar#setting").
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * Type of the resource ("calendar#setting").
   * The value set may be {@code null}.
   */
  public Setting setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Value of the user setting. The format of the value depends on the ID of the setting.
   * The value returned may be {@code null}.
   */
  public String getValue() {
    return value;
  }

  /**
   * Value of the user setting. The format of the value depends on the ID of the setting.
   * The value set may be {@code null}.
   */
  public Setting setValue(String value) {
    this.value = value;
    return this;
  }

}
