/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.calendar.model;

import com.google.api.client.json.GenericJson;
import com.google.api.client.util.DateTime;

/**
 * Model definition for TimePeriod.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Calendar API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class TimePeriod extends GenericJson {

  /**
   * The (exclusive) end of the time period.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private DateTime end;

  /**
   * The (inclusive) start of the time period.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private DateTime start;

  /**
   * The (exclusive) end of the time period.
   * The value returned may be {@code null}.
   */
  public DateTime getEnd() {
    return end;
  }

  /**
   * The (exclusive) end of the time period.
   * The value set may be {@code null}.
   */
  public TimePeriod setEnd(DateTime end) {
    this.end = end;
    return this;
  }

  /**
   * The (inclusive) start of the time period.
   * The value returned may be {@code null}.
   */
  public DateTime getStart() {
    return start;
  }

  /**
   * The (inclusive) start of the time period.
   * The value set may be {@code null}.
   */
  public TimePeriod setStart(DateTime start) {
    this.start = start;
    return this;
  }

}
